//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Server.UnobservableCommandTest
{
    
    
    /// <summary>
    /// A class that exposes the IUnobservableCommandTest interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class UnobservableCommandTestProvider : IFeatureProvider
    {
        
        private IUnobservableCommandTest _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(UnobservableCommandTestProvider).Assembly, "UnobservableCommandTest.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public UnobservableCommandTestProvider(IUnobservableCommandTest implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<CommandWithoutParametersAndResponsesRequestDto, EmptyRequest>("CommandWithoutParametersAndResponses", CommandWithoutParametersAndResponses);
            registration.RegisterUnobservableCommand<ConvertIntegerToStringRequestDto, ConvertIntegerToStringResponseDto>("ConvertIntegerToString", ConvertIntegerToString);
            registration.RegisterUnobservableCommand<JoinIntegerAndStringRequestDto, JoinIntegerAndStringResponseDto>("JoinIntegerAndString", JoinIntegerAndString);
            registration.RegisterUnobservableCommand<SplitStringAfterFirstCharacterRequestDto, SplitStringAfterFirstCharacterResponseDto>("SplitStringAfterFirstCharacter", SplitStringAfterFirstCharacter);
        }
        
        /// <summary>
        /// Executes the Command Without Parameters And Responses command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest CommandWithoutParametersAndResponses(CommandWithoutParametersAndResponsesRequestDto request)
        {
            request.Validate();
            _implementation.CommandWithoutParametersAndResponses();
            return EmptyRequest.Instance;
        }
        
        /// <summary>
        /// Executes the Convert Integer To String command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual ConvertIntegerToStringResponseDto ConvertIntegerToString(ConvertIntegerToStringRequestDto request)
        {
            try
            {
                request.Validate();
                return new ConvertIntegerToStringResponseDto(_implementation.ConvertIntegerToString(request.Integer.TryExtract(_server, "org.silastandard/test/UnobservableCommandTest/v1/Command/ConvertIntegerToString/P" +
                                "arameter/Integer")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "integer"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/UnobservableCommandTest/v1/Command/ConvertIntegerToString/P" +
                            "arameter/Integer", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Join Integer And String command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual JoinIntegerAndStringResponseDto JoinIntegerAndString(JoinIntegerAndStringRequestDto request)
        {
            try
            {
                request.Validate();
                return new JoinIntegerAndStringResponseDto(_implementation.JoinIntegerAndString(request.Integer.TryExtract(_server, "org.silastandard/test/UnobservableCommandTest/v1/Command/JoinIntegerAndString/Par" +
                                "ameter/Integer"), request.String.TryExtract(_server, "org.silastandard/test/UnobservableCommandTest/v1/Command/JoinIntegerAndString/Par" +
                                "ameter/String")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "integer"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/UnobservableCommandTest/v1/Command/JoinIntegerAndString/Par" +
                            "ameter/Integer", ex.Message);
                }
                if ((ex.ParamName == "string"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/UnobservableCommandTest/v1/Command/JoinIntegerAndString/Par" +
                            "ameter/String", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Split String After First Character command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual SplitStringAfterFirstCharacterResponseDto SplitStringAfterFirstCharacter(SplitStringAfterFirstCharacterRequestDto request)
        {
            try
            {
                request.Validate();
                return new SplitStringAfterFirstCharacterResponseDto(_implementation.SplitStringAfterFirstCharacter(request.String.TryExtract(_server, "org.silastandard/test/UnobservableCommandTest/v1/Command/SplitStringAfterFirstCha" +
                                "racter/Parameter/String")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "string"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/UnobservableCommandTest/v1/Command/SplitStringAfterFirstCha" +
                            "racter/Parameter/String", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/test/UnobservableCommandTest/v1/Command/CommandWithoutParameters" +
                "AndResponses"))
            {
                return typeof(IUnobservableCommandTest).GetMethod("CommandWithoutParametersAndResponses");
            }
            if ((commandIdentifier == "org.silastandard/test/UnobservableCommandTest/v1/Command/ConvertIntegerToString"))
            {
                return typeof(IUnobservableCommandTest).GetMethod("ConvertIntegerToString");
            }
            if ((commandIdentifier == "org.silastandard/test/UnobservableCommandTest/v1/Command/JoinIntegerAndString"))
            {
                return typeof(IUnobservableCommandTest).GetMethod("JoinIntegerAndString");
            }
            if ((commandIdentifier == "org.silastandard/test/UnobservableCommandTest/v1/Command/SplitStringAfterFirstCha" +
                "racter"))
            {
                return typeof(IUnobservableCommandTest).GetMethod("SplitStringAfterFirstCharacter");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            return null;
        }
    }
}

